require 'drb'

class MontyAgent 

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @monty = DRbObject.new(nil, 'druby://localhost:9070')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    orig_input = input
    if input =~ /^monty[:, ]* (.*)/i then input = $1.strip end
    response, score = @monty.getResponse(input)
    if score == nil 
      score = 1 
    end
    if input =~ /(?:subject|object|verb)/ then score += 3 end
    if response.to_s =~ /Default response/ then score = 0 end
    if orig_input =~ /^monty[:, ]*/i then score += 2 end
    if orig_input =~ /^monty[:, ]* help/i then score += 4 end
    if response.to_s.strip == '' or response == nil then score = 0 end
    puts "Monty: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse(["#{response}", score])
  end

end
